Index: /pjproject/main/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- /pjproject/main/pjsip/src/pjsip/sip_transaction.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsip/sip_transaction.c	(revision 43)
@@ -1415,12 +1428,13 @@
      * "Proceeding" state.
      */
-    result = pjsip_tsx_on_state_proceeding_uas( tsx, event);
+    status = pjsip_tsx_on_state_proceeding_uas( tsx, event);
 
     /* Inform the TU of the state transision if state is still State_Trying */
-    if (result==0 && tsx->state == PJSIP_TSX_STATE_TRYING) {
-	tsx_set_state( tsx, PJSIP_TSX_STATE_PROCEEDING, event);
-    }
-
-    return result;
+    if (status==PJ_SUCCESS && tsx->state == PJSIP_TSX_STATE_TRYING) {
+	tsx_set_state( tsx, PJSIP_TSX_STATE_PROCEEDING, 
+                       PJSIP_EVENT_TX_MSG, event->body.tx_msg.tdata);
+    }
+
+    return status;
 }
 
@@ -1429,5 +1443,6 @@
  * This state happens after the TU sends provisional response.
  */
-static int pjsip_tsx_on_state_proceeding_uas( pjsip_transaction *tsx, pjsip_event *event)
+static pj_status_t pjsip_tsx_on_state_proceeding_uas( pjsip_transaction *tsx,
+                                                      pjsip_event *event)
 {
     pj_assert(tsx->state == PJSIP_TSX_STATE_PROCEEDING || 
@@ -1440,11 +1455,15 @@
     if (event->type == PJSIP_EVENT_RX_MSG) {
 
+        pj_status_t status;
+
 	/* Send last response. */
-	if (pjsip_tsx_retransmit( tsx, 0 ) != 0) {
-	    return -1;
+        status = pjsip_tsx_retransmit( tsx, 0 );
+	if (status != PJ_SUCCESS) {
+	    return status;
 	}
 	
     } else if (event->type == PJSIP_EVENT_TX_MSG ) {
-	pjsip_tx_data *tdata = event->src.tdata;
+	pjsip_tx_data *tdata = event->body.tx_msg.tdata;
+        pj_status_t status;
 
 	/* The TU sends response message to the request. Save this message so
@@ -1472,6 +1491,7 @@
 
 	/* Send the message. */
-	if (tsx_send_msg(tsx, tdata) != 0) {
-	    return -1;
+        status = tsx_send_msg(tsx, tdata);
+	if (status != PJ_SUCCESS) {
+	    return status;
 	}
 
@@ -1486,5 +1506,6 @@
 		pjsip_tx_data_add_ref( tdata );
 	    }
-	    tsx_set_state( tsx, PJSIP_TSX_STATE_PROCEEDING, event);
+	    tsx_set_state( tsx, PJSIP_TSX_STATE_PROCEEDING, 
+                           PJSIP_EVENT_TX_MSG, tdata );
 
 	} else if (PJSIP_IS_STATUS_IN_CLASS(tsx->status_code, 200)) {
@@ -1492,11 +1513,12 @@
 	    if (tsx->method.id == PJSIP_INVITE_METHOD && tsx->handle_ack==0) {
 
-		/* 2xx class message is not saved, because retransmission is handled
-		 * by the TU.
+		/* 2xx class message is not saved, because retransmission 
+                 * is handled by TU.
 		 */
-		tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, event);
+		tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+                               PJSIP_EVENT_TX_MSG, tdata );
 
 		/* Transaction is destroyed. */
-		return -1;
+		return PJSIP_ETSXDESTROYED;
 
 	    } else {
@@ -1505,5 +1527,6 @@
 		if (tsx->method.id == PJSIP_INVITE_METHOD) {
 		    tsx->retransmit_count = 0;
-		    pjsip_endpt_schedule_timer( tsx->endpt, &tsx->retransmit_timer, 
+		    pjsip_endpt_schedule_timer( tsx->endpt, 
+                                                &tsx->retransmit_timer, 
 						&t1_timer_val);
 		}
@@ -1526,13 +1549,17 @@
 		}
 
-		pjsip_endpt_schedule_timer( tsx->endpt, &tsx->timeout_timer, &timeout);
+		pjsip_endpt_schedule_timer( tsx->endpt, &tsx->timeout_timer, 
+                                            &timeout);
 
 		/* Set state to "Completed" */
-		tsx_set_state( tsx, PJSIP_TSX_STATE_COMPLETED, event);
+		tsx_set_state( tsx, PJSIP_TSX_STATE_COMPLETED, 
+                               PJSIP_EVENT_TX_MSG, tdata );
 	    }
 
 	} else if (tsx->status_code >= 300) {
 
-	    /* 3xx-6xx class message causes transaction to move to "Completed" state. */
+	    /* 3xx-6xx class message causes transaction to move to 
+             * "Completed" state. 
+             */
 	    if (tsx->last_tx != tdata) {
 		tsx->last_tx = tdata;
@@ -1541,5 +1568,6 @@
 
 	    /* Start timer H for transaction termination */
-	    pjsip_endpt_schedule_timer(tsx->endpt,&tsx->timeout_timer,&timeout_timer_val);
+	    pjsip_endpt_schedule_timer(tsx->endpt,&tsx->timeout_timer,
+                                       &timeout_timer_val);
 
 	    /* For INVITE, if unreliable transport is used, retransmission 
@@ -1547,8 +1575,10 @@
 	     */
 	    if (PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)==0) {
-		pjsip_cseq_hdr *cseq = pjsip_msg_find_hdr( msg, PJSIP_H_CSEQ, NULL);
+		pjsip_cseq_hdr *cseq = pjsip_msg_find_hdr( msg, PJSIP_H_CSEQ,
+                                                           NULL);
 		if (cseq->method.id == PJSIP_INVITE_METHOD) {
 		    tsx->retransmit_count = 0;
-		    pjsip_endpt_schedule_timer(tsx->endpt, &tsx->retransmit_timer, 
+		    pjsip_endpt_schedule_timer(tsx->endpt, 
+                                               &tsx->retransmit_timer, 
 					       &t1_timer_val);
 		}
@@ -1556,5 +1586,6 @@
 
 	    /* Inform TU */
-	    tsx_set_state( tsx, PJSIP_TSX_STATE_COMPLETED, event);
+	    tsx_set_state( tsx, PJSIP_TSX_STATE_COMPLETED, 
+                           PJSIP_EVENT_TX_MSG, tdata );
 
 	} else {
@@ -1564,6 +1595,7 @@
 
     } else if (event->type == PJSIP_EVENT_TIMER && 
-	       event->src.timer == &tsx->retransmit_timer) {
+	       event->body.timer.entry == &tsx->retransmit_timer) {
 	/* Retransmission timer elapsed. */
+        pj_status_t status;
 
 	/* Must have last response to retransmit. */
@@ -1571,10 +1603,11 @@
 
 	/* Retransmit the last response. */
-	if (pjsip_tsx_retransmit( tsx, 1 ) != 0) {
-	    return -1;
+        status = pjsip_tsx_retransmit( tsx, 1 );
+	if (status != PJ_SUCCESS) {
+	    return status;
 	}
 
     } else if (event->type == PJSIP_EVENT_TIMER && 
-	       event->src.timer == &tsx->timeout_timer) {
+	       event->body.timer.entry == &tsx->timeout_timer) {
 
 	/* Timeout timer. should not happen? */
@@ -1583,13 +1616,15 @@
 	tsx->status_code = PJSIP_SC_TSX_TIMEOUT;
 
-	tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, event);
-
-	return -1;
+	tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+                       PJSIP_EVENT_TIMER, &tsx->timeout_timer);
+
+	return PJ_EBUG;
 
     } else {
 	pj_assert(0);
-    }
-
-    return 0;
+        return PJ_EBUG;
+    }
+
+    return PJ_SUCCESS;
 }
 
@@ -1599,5 +1634,6 @@
  * UAS.
  */
-static int pjsip_tsx_on_state_proceeding_uac( pjsip_transaction *tsx, pjsip_event *event)
+static pj_status_t pjsip_tsx_on_state_proceeding_uac(pjsip_transaction *tsx, 
+                                                     pjsip_event *event)
 {
 
@@ -1611,8 +1647,8 @@
 	pj_assert(event->type == PJSIP_EVENT_RX_MSG);
 	if (event->type != PJSIP_EVENT_RX_MSG) {
-	    return 0;
-	}
-
-	tsx->status_code = event->src.rdata->msg->line.status.code;
+	    return PJ_EINVALIDOP;
+	}
+
+	tsx->status_code = event->body.rx_msg.rdata->msg->line.status.code;
     } else {
 	tsx->status_code = PJSIP_SC_TSX_TIMEOUT;
@@ -1622,5 +1658,6 @@
 
 	/* Inform the message to TU. */
-	tsx_set_state( tsx, PJSIP_TSX_STATE_PROCEEDING, event);
+	tsx_set_state( tsx, PJSIP_TSX_STATE_PROCEEDING, 
+                       PJSIP_EVENT_RX_MSG, event->body.rx_msg.rdata );
 
     } else if (PJSIP_IS_STATUS_IN_CLASS(tsx->status_code,200)) {
@@ -1633,6 +1670,7 @@
 	 */
 	if (tsx->method.id == PJSIP_INVITE_METHOD && tsx->handle_ack == 0) {
-	    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, event);
-	    return -1;
+	    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+                           PJSIP_EVENT_RX_MSG, event->body.rx_msg.rdata );
+	    return PJSIP_ETSXDESTROYED;
 
 	} else {
@@ -1650,12 +1688,15 @@
 		timeout.sec = timeout.msec = 0;
 	    }
-	    pjsip_endpt_schedule_timer( tsx->endpt, &tsx->timeout_timer, &timeout);
+	    pjsip_endpt_schedule_timer( tsx->endpt, &tsx->timeout_timer, 
+					&timeout);
 
 	    /* Move state to Completed, inform TU. */
-	    tsx_set_state( tsx, PJSIP_TSX_STATE_COMPLETED, event);
+	    tsx_set_state( tsx, PJSIP_TSX_STATE_COMPLETED, 
+                           PJSIP_EVENT_RX_MSG, event->body.rx_msg.rdata );
 	}
 
     } else if (tsx->status_code >= 300 && tsx->status_code <= 699) {
 	pj_time_val timeout;
+        pj_status_t status;
 
 	/* Stop timer B. */
@@ -1664,7 +1705,9 @@
 	/* Generate and send ACK for INVITE. */
 	if (tsx->method.id == PJSIP_INVITE_METHOD) {
-	    pjsip_endpt_create_ack( tsx->endpt, tsx->last_tx, event->src.rdata );
-	    if (tsx_send_msg( tsx, tsx->last_tx) != 0) {
-		return -1;
+	    pjsip_endpt_create_ack( tsx->endpt, tsx->last_tx, 
+                                    event->body.rx_msg.rdata );
+            status = tsx_send_msg( tsx, tsx->last_tx);
+	    if (status != PJ_SUCCESS) {
+		return status;
 	    }
 	}
@@ -1683,9 +1726,11 @@
 
 	/* Inform TU. */
-	tsx_set_state( tsx, PJSIP_TSX_STATE_COMPLETED, event);
+	tsx_set_state( tsx, PJSIP_TSX_STATE_COMPLETED, 
+                       PJSIP_EVENT_RX_MSG, event->body.rx_msg.rdata );
 
     } else {
 	// Shouldn't happen because there's no timer for this state.
 	pj_assert(0);
+        return PJ_EBUG;
     }
 
@@ -1696,16 +1741,20 @@
  * Handler for events in Completed state for UAS
  */
-static int pjsip_tsx_on_state_completed_uas( pjsip_transaction *tsx, pjsip_event *event)
+static pj_status_t pjsip_tsx_on_state_completed_uas( pjsip_transaction *tsx, 
+                                                     pjsip_event *event)
 {
     pj_assert(tsx->state == PJSIP_TSX_STATE_COMPLETED);
 
     if (event->type == PJSIP_EVENT_RX_MSG) {
-	pjsip_msg *msg = event->src.rdata->msg;
+	pjsip_msg *msg = event->body.rx_msg.rdata->msg;
 	pjsip_cseq_hdr *cseq = pjsip_msg_find_hdr( msg, PJSIP_H_CSEQ, NULL );
 
 	/* On receive request retransmission, retransmit last response. */
 	if (cseq->method.id != PJSIP_ACK_METHOD) {
-	    if (pjsip_tsx_retransmit( tsx, 0 ) != 0) {
-		return -1;
+            pj_status_t status;
+
+            status = pjsip_tsx_retransmit( tsx, 0 );
+	    if (status != PJ_SUCCESS) {
+		return status;
 	    }
 
@@ -1718,16 +1767,21 @@
 	    /* Start timer I in T4 interval (transaction termination). */
 	    pjsip_endpt_cancel_timer( tsx->endpt, &tsx->timeout_timer );
-	    pjsip_endpt_schedule_timer( tsx->endpt, &tsx->timeout_timer, &t4_timer_val);
+	    pjsip_endpt_schedule_timer( tsx->endpt, &tsx->timeout_timer, 
+					&t4_timer_val);
 
 	    /* Move state to "Confirmed" */
-	    tsx_set_state( tsx, PJSIP_TSX_STATE_CONFIRMED, event);
+	    tsx_set_state( tsx, PJSIP_TSX_STATE_CONFIRMED, 
+                           PJSIP_EVENT_RX_MSG, event->body.rx_msg.rdata );
 	}	
 
     } else if (event->type == PJSIP_EVENT_TIMER) {
 
-	if (event->src.timer == &tsx->retransmit_timer) {
+	if (event->body.timer.entry == &tsx->retransmit_timer) {
 	    /* Retransmit message. */
-	    if (pjsip_tsx_retransmit( tsx, 1 ) != 0) {
-		return -1;
+            pj_status_t status;
+
+            status = pjsip_tsx_retransmit( tsx, 1 );
+	    if (status != PJ_SUCCESS) {
+		return status;
 	    }
 
@@ -1741,12 +1795,14 @@
 		tsx->status_code = PJSIP_SC_TSX_TIMEOUT;
 
-		tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, event);
-
-		return -1;
+		tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+                               PJSIP_EVENT_TIMER, &tsx->timeout_timer );
+
+		return PJSIP_ETSXDESTROYED;
 
 	    } else {
 		/* Transaction terminated, it can now be deleted. */
-		tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, event);
-		return -1;
+		tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+                               PJSIP_EVENT_TIMER, &tsx->timeout_timer );
+		return PJSIP_ETSXDESTROYED;
 	    }
 	}
@@ -1754,5 +1810,5 @@
     } else {
 	/* Ignore request to transmit. */
-	pj_assert(event->src.tdata == tsx->last_tx);
+	pj_assert(event->body.tx_msg.tdata == tsx->last_tx);
     }
 
@@ -1763,5 +1819,6 @@
  * Handler for events in Completed state for UAC transaction.
  */
-static int pjsip_tsx_on_state_completed_uac( pjsip_transaction *tsx, pjsip_event *event)
+static pj_status_t pjsip_tsx_on_state_completed_uac( pjsip_transaction *tsx,
+                                                     pjsip_event *event)
 {
     pj_assert(tsx->state == PJSIP_TSX_STATE_COMPLETED);
@@ -1769,11 +1826,12 @@
     if (event->type == PJSIP_EVENT_TIMER) {
 	/* Must be the timeout timer. */
-	pj_assert(event->src.timer == &tsx->timeout_timer);
+	pj_assert(event->body.timer.entry == &tsx->timeout_timer);
 
 	/* Move to Terminated state. */
-	tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, event);
+	tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+                       PJSIP_EVENT_TIMER, event->body.timer.entry );
 
 	/* Transaction has been destroyed. */
-	return -1;
+	return PJSIP_ETSXDESTROYED;
 
     } else if (event->type == PJSIP_EVENT_RX_MSG) {
@@ -1782,11 +1840,14 @@
 	     * TU doesn't need to be informed.
 	     */
-	    pjsip_msg *msg = event->src.rdata->msg;
+	    pjsip_msg *msg = event->body.rx_msg.rdata->msg;
 	    pj_assert(msg->type == PJSIP_RESPONSE_MSG);
 	    if (msg->type==PJSIP_RESPONSE_MSG &&
 		msg->line.status.code >= 200)
 	    {
-		if (pjsip_tsx_retransmit( tsx, 0 ) != 0) {
-		    return -1;
+                pj_status_t status;
+
+                status = pjsip_tsx_retransmit( tsx, 0 );
+		if (status != PJ_SUCCESS) {
+		    return status;
 		}
 	    } else {
@@ -1799,10 +1860,12 @@
     } else if (tsx->method.id == PJSIP_INVITE_METHOD &&
 	       event->type == PJSIP_EVENT_TX_MSG &&
-	       event->src.tdata->msg->line.req.method.id == PJSIP_ACK_METHOD) {
+	       event->body.tx_msg.tdata->msg->line.req.method.id==PJSIP_ACK_METHOD) {
+
+        pj_status_t status;
 
 	/* Set last transmitted message. */
-	if (tsx->last_tx != event->src.tdata) {
+	if (tsx->last_tx != event->body.tx_msg.tdata) {
 	    pjsip_tx_data_dec_ref( tsx->last_tx );
-	    tsx->last_tx = event->src.tdata;
+	    tsx->last_tx = event->body.tx_msg.tdata;
 	    pjsip_tx_data_add_ref( tsx->last_tx );
 	}
@@ -1811,14 +1874,18 @@
 	 * Must notify now, so app has chance to put SDP in outgoing ACK msg.
 	 */
-	tsx_set_state( tsx, PJSIP_TSX_STATE_COMPLETED, event );
+	tsx_set_state( tsx, PJSIP_TSX_STATE_COMPLETED, 
+                       PJSIP_EVENT_TX_MSG, event->body.tx_msg.tdata );
 
 	/* Send msg */
-	tsx_send_msg(tsx, event->src.tdata);
+	status = tsx_send_msg(tsx, event->body.tx_msg.tdata);
+        if (status != PJ_SUCCESS)
+            return status;
 
     } else {
 	pj_assert(0);
-    }
-
-    return 0;
+        return PJ_EBUG;
+    }
+
+    return PJ_SUCCESS;
 }
 
@@ -1826,5 +1893,6 @@
  * Handler for events in state Confirmed.
  */
-static int pjsip_tsx_on_state_confirmed( pjsip_transaction *tsx, pjsip_event *event)
+static pj_status_t pjsip_tsx_on_state_confirmed( pjsip_transaction *tsx,
+                                                 pjsip_event *event)
 {
     pj_assert(tsx->state == PJSIP_TSX_STATE_CONFIRMED);
@@ -1836,23 +1904,34 @@
     /* Absorb any ACK received. */
     if (event->type == PJSIP_EVENT_RX_MSG) {
+
+        pjsip_method_e method_id = 
+            event->body.rx_msg.rdata->msg->line.req.method.id;
+
 	/* Must be a request message. */
-	pj_assert(event->src.rdata->msg->type == PJSIP_REQUEST_MSG);
+	pj_assert(event->body.rx_msg.rdata->msg->type == PJSIP_REQUEST_MSG);
 
 	/* Must be an ACK request or a late INVITE retransmission. */
-	pj_assert(event->src.rdata->msg->line.req.method.id == PJSIP_ACK_METHOD ||
-		  event->src.rdata->msg->line.req.method.id == PJSIP_INVITE_METHOD);
+	pj_assert(method_id == PJSIP_ACK_METHOD ||
+		  method_id == PJSIP_INVITE_METHOD);
+
+        /* Just so that compiler won't complain about unused vars when
+         * building release code.
+         */
+        PJ_UNUSED_ARG(method_id);
 
     } else if (event->type == PJSIP_EVENT_TIMER) {
 	/* Must be from timeout_timer_. */
-	pj_assert(event->src.timer == &tsx->timeout_timer);
+	pj_assert(event->body.timer.entry == &tsx->timeout_timer);
 
 	/* Move to Terminated state. */
-	tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, event);
+	tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+                       PJSIP_EVENT_TIMER, &tsx->timeout_timer );
 
 	/* Transaction has been destroyed. */
-	return -1;
+	return PJSIP_ETSXDESTROYED;
 
     } else {
 	pj_assert(0);
+        return PJ_EBUG;
     }
 
@@ -1863,12 +1942,14 @@
  * Handler for events in state Terminated.
  */
-static int pjsip_tsx_on_state_terminated( pjsip_transaction *tsx, pjsip_event *event)
+static pj_status_t pjsip_tsx_on_state_terminated( pjsip_transaction *tsx,
+                                                  pjsip_event *event)
 {
     pj_assert(tsx->state == PJSIP_TSX_STATE_TERMINATED);
 
-    PJ_UNUSED_ARG(event)
+    PJ_UNUSED_ARG(event);
 
     /* Destroy this transaction */
-    tsx_set_state(tsx, PJSIP_TSX_STATE_DESTROYED, event);
+    tsx_set_state(tsx, PJSIP_TSX_STATE_DESTROYED, 
+                  event->type, event->body.user.user1 );
 
     return PJ_SUCCESS;
@@ -1876,8 +1957,9 @@
 
 
-static int pjsip_tsx_on_state_destroyed( pjsip_transaction *tsx, pjsip_event *event)
-{
-    PJ_UNUSED_ARG(tsx)
-    PJ_UNUSED_ARG(event)
+static pj_status_t pjsip_tsx_on_state_destroyed(pjsip_transaction *tsx,
+                                                pjsip_event *event)
+{
+    PJ_UNUSED_ARG(tsx);
+    PJ_UNUSED_ARG(event);
     return PJ_SUCCESS;
 }
